<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFlightTouched ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFlightTouched
 * @subpackage Arrays
 */
class ArrayOfFlightTouched extends AbstractStructArrayBase
{
    /**
     * The FlightTouched
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FlightTouched[]
     */
    public $FlightTouched;
    /**
     * Constructor method for ArrayOfFlightTouched
     * @uses ArrayOfFlightTouched::setFlightTouched()
     * @param \StructType\FlightTouched[] $flightTouched
     */
    public function __construct(array $flightTouched = array())
    {
        $this
            ->setFlightTouched($flightTouched);
    }
    /**
     * Get FlightTouched value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FlightTouched[]|null
     */
    public function getFlightTouched()
    {
        return isset($this->FlightTouched) ? $this->FlightTouched : null;
    }
    /**
     * Set FlightTouched value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FlightTouched[] $flightTouched
     * @return \ArrayType\ArrayOfFlightTouched
     */
    public function setFlightTouched(array $flightTouched = array())
    {
        foreach ($flightTouched as $arrayOfFlightTouchedFlightTouchedItem) {
            // validation for constraint: itemType
            if (!$arrayOfFlightTouchedFlightTouchedItem instanceof \StructType\FlightTouched) {
                throw new \InvalidArgumentException(sprintf('The FlightTouched property can only contain items of \StructType\FlightTouched, "%s" given', is_object($arrayOfFlightTouchedFlightTouchedItem) ? get_class($arrayOfFlightTouchedFlightTouchedItem) : gettype($arrayOfFlightTouchedFlightTouchedItem)), __LINE__);
            }
        }
        if (is_null($flightTouched) || (is_array($flightTouched) && empty($flightTouched))) {
            unset($this->FlightTouched);
        } else {
            $this->FlightTouched = $flightTouched;
        }
        return $this;
    }
    /**
     * Add item to FlightTouched value
     * @throws \InvalidArgumentException
     * @param \StructType\FlightTouched $item
     * @return \ArrayType\ArrayOfFlightTouched
     */
    public function addToFlightTouched(\StructType\FlightTouched $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FlightTouched) {
            throw new \InvalidArgumentException(sprintf('The FlightTouched property can only contain items of \StructType\FlightTouched, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->FlightTouched[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FlightTouched|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FlightTouched|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FlightTouched|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FlightTouched|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FlightTouched|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FlightTouched
     */
    public function getAttributeName()
    {
        return 'FlightTouched';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfFlightTouched
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
