<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FlightChanges StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:FlightChanges
 * @subpackage Structs
 */
class FlightChanges extends AbstractStructBase
{
    /**
     * The DeletedFlights
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfFlightTouched
     */
    public $DeletedFlights;
    /**
     * The InsertedFlights
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfFlightTouched
     */
    public $InsertedFlights;
    /**
     * The UpdatedFlights
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfFlightTouched
     */
    public $UpdatedFlights;
    /**
     * Constructor method for FlightChanges
     * @uses FlightChanges::setDeletedFlights()
     * @uses FlightChanges::setInsertedFlights()
     * @uses FlightChanges::setUpdatedFlights()
     * @param \ArrayType\ArrayOfFlightTouched $deletedFlights
     * @param \ArrayType\ArrayOfFlightTouched $insertedFlights
     * @param \ArrayType\ArrayOfFlightTouched $updatedFlights
     */
    public function __construct(\ArrayType\ArrayOfFlightTouched $deletedFlights = null, \ArrayType\ArrayOfFlightTouched $insertedFlights = null, \ArrayType\ArrayOfFlightTouched $updatedFlights = null)
    {
        $this
            ->setDeletedFlights($deletedFlights)
            ->setInsertedFlights($insertedFlights)
            ->setUpdatedFlights($updatedFlights);
    }
    /**
     * Get DeletedFlights value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfFlightTouched|null
     */
    public function getDeletedFlights()
    {
        return isset($this->DeletedFlights) ? $this->DeletedFlights : null;
    }
    /**
     * Set DeletedFlights value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfFlightTouched $deletedFlights
     * @return \StructType\FlightChanges
     */
    public function setDeletedFlights(\ArrayType\ArrayOfFlightTouched $deletedFlights = null)
    {
        if (is_null($deletedFlights) || (is_array($deletedFlights) && empty($deletedFlights))) {
            unset($this->DeletedFlights);
        } else {
            $this->DeletedFlights = $deletedFlights;
        }
        return $this;
    }
    /**
     * Get InsertedFlights value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfFlightTouched|null
     */
    public function getInsertedFlights()
    {
        return isset($this->InsertedFlights) ? $this->InsertedFlights : null;
    }
    /**
     * Set InsertedFlights value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfFlightTouched $insertedFlights
     * @return \StructType\FlightChanges
     */
    public function setInsertedFlights(\ArrayType\ArrayOfFlightTouched $insertedFlights = null)
    {
        if (is_null($insertedFlights) || (is_array($insertedFlights) && empty($insertedFlights))) {
            unset($this->InsertedFlights);
        } else {
            $this->InsertedFlights = $insertedFlights;
        }
        return $this;
    }
    /**
     * Get UpdatedFlights value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfFlightTouched|null
     */
    public function getUpdatedFlights()
    {
        return isset($this->UpdatedFlights) ? $this->UpdatedFlights : null;
    }
    /**
     * Set UpdatedFlights value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfFlightTouched $updatedFlights
     * @return \StructType\FlightChanges
     */
    public function setUpdatedFlights(\ArrayType\ArrayOfFlightTouched $updatedFlights = null)
    {
        if (is_null($updatedFlights) || (is_array($updatedFlights) && empty($updatedFlights))) {
            unset($this->UpdatedFlights);
        } else {
            $this->UpdatedFlights = $updatedFlights;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\FlightChanges
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
