<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PPSCustomerIdentification StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:PPSCustomerIdentification
 * @subpackage Structs
 */
class PPSCustomerIdentification extends AbstractStructBase
{
    /**
     * The CBPassword
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CBPassword;
    /**
     * The CBUser
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CBUser;
    /**
     * The PPSName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PPSName;
    /**
     * Constructor method for PPSCustomerIdentification
     * @uses PPSCustomerIdentification::setCBPassword()
     * @uses PPSCustomerIdentification::setCBUser()
     * @uses PPSCustomerIdentification::setPPSName()
     * @param string $cBPassword
     * @param string $cBUser
     * @param string $pPSName
     */
    public function __construct($cBPassword = null, $cBUser = null, $pPSName = null)
    {
        $this
            ->setCBPassword($cBPassword)
            ->setCBUser($cBUser)
            ->setPPSName($pPSName);
    }
    /**
     * Get CBPassword value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCBPassword()
    {
        return isset($this->CBPassword) ? $this->CBPassword : null;
    }
    /**
     * Set CBPassword value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cBPassword
     * @return \StructType\PPSCustomerIdentification
     */
    public function setCBPassword($cBPassword = null)
    {
        // validation for constraint: string
        if (!is_null($cBPassword) && !is_string($cBPassword)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cBPassword)), __LINE__);
        }
        if (is_null($cBPassword) || (is_array($cBPassword) && empty($cBPassword))) {
            unset($this->CBPassword);
        } else {
            $this->CBPassword = $cBPassword;
        }
        return $this;
    }
    /**
     * Get CBUser value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCBUser()
    {
        return isset($this->CBUser) ? $this->CBUser : null;
    }
    /**
     * Set CBUser value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cBUser
     * @return \StructType\PPSCustomerIdentification
     */
    public function setCBUser($cBUser = null)
    {
        // validation for constraint: string
        if (!is_null($cBUser) && !is_string($cBUser)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cBUser)), __LINE__);
        }
        if (is_null($cBUser) || (is_array($cBUser) && empty($cBUser))) {
            unset($this->CBUser);
        } else {
            $this->CBUser = $cBUser;
        }
        return $this;
    }
    /**
     * Get PPSName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPPSName()
    {
        return isset($this->PPSName) ? $this->PPSName : null;
    }
    /**
     * Set PPSName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $pPSName
     * @return \StructType\PPSCustomerIdentification
     */
    public function setPPSName($pPSName = null)
    {
        // validation for constraint: string
        if (!is_null($pPSName) && !is_string($pPSName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($pPSName)), __LINE__);
        }
        if (is_null($pPSName) || (is_array($pPSName) && empty($pPSName))) {
            unset($this->PPSName);
        } else {
            $this->PPSName = $pPSName;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PPSCustomerIdentification
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
