<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UploadScheduledFlights StructType
 * @subpackage Structs
 */
class UploadScheduledFlights extends AbstractStructBase
{
    /**
     * The Flights
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfFlight
     */
    public $Flights;
    /**
     * Constructor method for UploadScheduledFlights
     * @uses UploadScheduledFlights::setFlights()
     * @param \ArrayType\ArrayOfFlight $flights
     */
    public function __construct(\ArrayType\ArrayOfFlight $flights = null)
    {
        $this
            ->setFlights($flights);
    }
    /**
     * Get Flights value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfFlight|null
     */
    public function getFlights()
    {
        return isset($this->Flights) ? $this->Flights : null;
    }
    /**
     * Set Flights value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfFlight $flights
     * @return \StructType\UploadScheduledFlights
     */
    public function setFlights(\ArrayType\ArrayOfFlight $flights = null)
    {
        if (is_null($flights) || (is_array($flights) && empty($flights))) {
            unset($this->Flights);
        } else {
            $this->Flights = $flights;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UploadScheduledFlights
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
